'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : [select VIEW...EDITOR OPTIONS]                    *
'*  Notice  : Copyright (c) 2010 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 9/11/2010                                         *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
; declares
Dim TEXT[15] As Byte             ' HOLDS THE CHARACTER TO BE PRINTED
';----- Nokia Aliases ------------------------
'Symbol Nokia_RESET =PORTB.3      ' RESET PIN ACTIVE LOW
'Symbol Nokia_CS    =PORTB.4      ' CHIP SELECT PIN ACTIVE LOW . COULD TIE TO GROUND
'Symbol Nokia_DC    =PORTB.5      ' DATA OR COMMAND PIN (LOW=COMMAND  ' HIGH=DATA)
'Symbol Nokia_SDA   =PORTB.6      ' SERIAL DATA
'Symbol Nokia_CLK   =PORTB.7      ' SERIAL CLOCK

;----- NOKIA DECLARES -------------------------------------------
Dim COMMAND_BYTE As Byte         ' USED TO SEND A COMMAND TO NOKIA 3310 LCD
Dim Y_POS As Byte                ' HOLDS THE VALUE FOR Y ROWS
Dim X_POS As Byte                ' HOLDS THE VALUE FOR X COLS
Dim T_COEF As Byte               ' HOLDS THE VALUE FOR TEMPERATURE COEFICIENT
Dim BIAS As Byte                 ' HOLDS THE VALUE OF SYSTEM BIAS
Dim VOP As Byte                  ' HOLDS THE VALUE FOR Vop
Dim TEMP1 As Byte                ' DUMMY VAR
Dim TEMP2 As Word                ' DUMMY VAR
Dim TEMP_FSR As Byte             ' TEMPORARY STORE FOR FSR
Dim MODE As Byte                 ' VIDEO MODE FOR TEXT
Dim BAR_VAL As Byte               ' HOLDS THE VALUE FOR THE VARIABLE TO BE BARGRAPHED
Dim BAR_MAX As Byte               ' HOLDS THE MAX X VALUE OF BARGRAPH
Dim ICON_NR As Byte               ' HOLDS THE ICON NUMBER VALUE TO BE DISPLAYED
Dim IMG_NR As Byte                ' HOLDS THE IMAGE NUMBER STORED IN MEMORY
;
Dim _fill_in_x01 As Byte
Dim _fill_in_x02 As Byte 
; subs
BRA OVER_SUBS

;----- START INITIALISATION ROUTINE -----------------------------
NOKIA_INI:
           DelayMS 50            ' DELAY 50MS AFTER VDD IS ON
           Output Nokia_RESET;TRISB.3 = 0
           Output Nokia_CS;TRISB.4 = 0
           Output Nokia_DC;TRISB.5 = 0
           Output Nokia_SDA;TRISB.6 = 0
           Output Nokia_CLK;TRISB.7 = 0
           Low Nokia_RESET       ' RESET PIN ACTIVE LOW
           DelayMS 50            ' KEEP RESET PIN LOW
           High Nokia_RESET      ' REVERT FROM RESET CONDITION
           Low Nokia_CS          ' ENABLE LCD
           Low Nokia_DC
           SHOut Nokia_SDA,Nokia_CLK,msbfirst,[$21,$C8,$06,$13,$20,$0C]
           High Nokia_DC
           Return

;----- NOKIA DISPLAY CONTROL ---------------------------------------
NOKIA_DISPLAY_BLANC:               ' DLANC DISPLAY
                 Low Nokia_DC
                 COMMAND_BYTE = %00001000
                 SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                 High Nokia_DC
                 clrf COMMAND_BYTE
                 Return
NOKIA_NORMAL_MODE:
                  Low Nokia_DC
                  COMMAND_BYTE = %00001100
                  SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                  High Nokia_DC
                  clrf COMMAND_BYTE
                  Return
NOKIA_ALL_SEGM_ON:                 ' NOKIA DISPLAY ALL SEGMENTS ON
                  Low Nokia_DC
                  COMMAND_BYTE = %00001001
                  SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                  High Nokia_DC
                  clrf COMMAND_BYTE
                  Return
NOKIA_INVERSE_MODE:
                  Low Nokia_DC
                  COMMAND_BYTE = %00001101
                  SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                  High Nokia_DC
                  clrf COMMAND_BYTE
                  Return
;--------------------------------------------------------------------

;----- NOKIA SETTINGS -----------------------------------------------

;----- BASIC INSTRUCTION SET ----------------------------------------

NOKIA_SET_Y:                        ' SET Y ADDRESS OF RAM      0 <= Y <= 5 LINES
                  'INPUT WITH VALUE FOR Y (I.E. Y=2)
                  Low Nokia_DC
                  COMMAND_BYTE = %01000000 + Y_POS
                  SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                  High Nokia_DC
                  clrf COMMAND_BYTE
                  Return
NOKIA_SET_X:                        ' SET X ADDRESS OF RAM      0 <= X <= 83 COLUMNS (BITS)
                  'INPUT WITH VALUE FOR X
                  Low Nokia_DC
                  COMMAND_BYTE = %10000000 + X_POS
                  SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                  High Nokia_DC
                  clrf COMMAND_BYTE
                  Return

;---------------------------------------------------------------------
NOKIA_PRINT_CHAR:       ' PRINT A CHAR ELEMENT FROM THE POINTED BY FSR ARRAY
                Dec FSR
                TEMP_FSR = FSR
                Repeat
                FSR = TEMP_FSR + 1 
                TEMP2 = INDF * 6
                If TEMP2 = 0 Then Break
                High Nokia_DC
                For TEMP1 = 0 To 5
                     COMMAND_BYTE = CRead NOKIA_FONT + TEMP2 + TEMP1
                     If MODE = 1 Then
                             COMMAND_BYTE = ~COMMAND_BYTE    ;FOR INVERSE MODE
                     EndIf        
                     SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
                Next    
                Low Nokia_DC               
                Inc TEMP_FSR
                Until TEMP2 = 0 ;INDF = 0
                clrf COMMAND_BYTE
                Return
                 
;-----------------------------------------------------------------------
NOKIA_CLEAR:     ' CLEAR SCREEN 
           High Nokia_DC
           For TEMP2 = 1 To 504
             COMMAND_BYTE=0
             SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
           Next
           clrf COMMAND_BYTE
           Return

;-----------------------------------------------------------------------
PIX_DO:
       High Nokia_DC
       SHOut Nokia_SDA,Nokia_CLK,msbfirst,[COMMAND_BYTE]
       Low Nokia_DC
       Return
;------------------------------------------------------------------------
NOKIA_BAR:
          X_POS = X_POS * 6 
          GoSub NOKIA_SET_Y
          GoSub NOKIA_SET_X
          For TEMP1 = 0 To BAR_VAL/2
              COMMAND_BYTE = $FF        ' MAKE IT A MARK  (THOUGH YOU CAN CHANGE THOSE TO SUIT YOUR NEED)
              GoSub PIX_DO
              COMMAND_BYTE = $00        ' MAKE IT A SPACE
              GoSub PIX_DO 
          Next
          For TEMP1 = (BAR_MAX - BAR_VAL) To BAR_MAX  ' CLEAR THE REST OF BARGRAPH SPACE
              COMMAND_BYTE = $00
              GoSub PIX_DO
          Next
          Return
;----------------------------------------------------------------
NOKIA_ICN:
          X_POS = X_POS * 6
          GoSub NOKIA_SET_Y                                            ' SET CURSOR POSITION
          GoSub NOKIA_SET_X
          For TEMP1 = 0 To 11
              COMMAND_BYTE = CRead ICON_ONE + TEMP1 + (ICON_NR * 24)   ' DRAW THE UPPER TWO CHAR POS
              GoSub PIX_DO
          Next
          Y_POS = Y_POS + 1                                            ' INCREASE Y BY 1 FOR THE LOWER CHARS
          GoSub NOKIA_SET_Y
          GoSub NOKIA_SET_X
          For TEMP1 = 12 To 23
              COMMAND_BYTE = CRead ICON_ONE + TEMP1 + (ICON_NR * 24)   ' DRAW THE LOWER TWO CHAR POS
              GoSub PIX_DO
          Next
          Return
;-----------------------------------------------------------------
NOKIA_IMG:
          X_POS = 0
          Y_POS = 0
          GoSub NOKIA_SET_X
          GoSub NOKIA_SET_Y
          For TEMP2 = 0 To 503
              COMMAND_BYTE = CRead SCREEN_ONE + TEMP2 + (IMG_NR * 504)
              If MODE = 1 Then COMMAND_BYTE = ~ COMMAND_BYTE
              GoSub PIX_DO
          Next
          Return
;------------------------------------------------------------------
OVER_SUBS:
; macros
BRA OVER_MACROS
;**************** M A C R O S ***********************************

;----- NOKIA CURSOR MACRO -----    ; use NOKIA_CURSOR Y,X

NOKIA_CURSOR Macro P1, P2          ; P2 = X ( 0 to 83)  and  P1 = Y ( 0 to 5 )
             NUM_byte P2, X_POS    ; STORE THE VALUE FOR X
             NUM_byte P1, Y_POS    ; STORE THE VALUE FOR Y
             GoSub _NOKIA_CURSOR_SUB
             Endm
_NOKIA_CURSOR_SUB:
             X_POS = X_POS * 6     ; IF YOU WANT CHARACTER POSITION RATHER THAN PIXEL 0 <= X <= 13
             GoSub NOKIA_SET_Y     ; SET Y
             GoSub NOKIA_SET_X     ; SET X
             clrf X_POS            ;
             clrf Y_POS            ;
             Return

;----- NOKIA INIT MACRO -------

NOKIA_INIT Macro
           GoSub NOKIA_INI         ; LCD INITIALISATION SEQUENCE
           Endm

;----- NOKIA CLS MACRO --------

NOKIA_CLS  Macro
           GoSub NOKIA_CLEAR       ; CLEAR SCREEN MACRO
           Endm


;----- NOKIA PRINT MACRO -------

NOKIA_PRINT  Macro P1,P2          'P1 = TEXT BUFFER ARRAY     P2 = 0 FOR NORMAL VIDEO OR 1 FOR INVERSE
             #if (P1>255)
                 bcf STATUS,7
             #endif
             NUM_BYTE P1, FSR
             NUM_BYTE P2, MODE
             GoSub NOKIA_PRINT_CHAR
             #if (P1>255)
                 bsf STATUS,7
             #endif
             Endm          

;----- NOKIA CGRAM MACRO --------

NOKIA_CGRAM Macro P1,P2,P3,P4,P5     ' For START CAN USE 5 CONSECUTIVE GRAPHIC CHARS (CAN ADD MORE..) 
            NUM_BYTE P1, TEXT#0      ' IF YOU WANT DISPLAYED ONLY ONE GRAPHIC CHAR THEN MAKE NEXT PARAMETER 0 (ZERO)
            NUM_BYTE P2, TEXT#1      ' AND DON'T NEED TO PUT THE REST OF PARAMS AFTER THAT ZERO.
            NUM_BYTE P3, TEXT#2
            NUM_BYTE P4, TEXT#3
            NUM_BYTE P5, TEXT#4
            GoSub _NOKIA_CGRAM_SUB
            Endm
_NOKIA_CGRAM_SUB:
            movlw 0
            movwf TEXT#5             ' NULL TERMINATE THE STRING
            NOKIA_PRINT TEXT,0       ' WILL PRINT IN NORMAL MODE   
            Return

;-----  NOKIA BARGRAPH MACRO ----
NOKIA_BARGRAPH Macro P1,P2,P3,P4            ; P1 = Y   P2 = X    P3 = VARIABLE    P4 = MAX X DISTANCE   
               BYTE_BYTE P3, BAR_VAL
               NUM_BYTE P4, BAR_MAX
               NUM_BYTE P1, Y_POS
               NUM_BYTE P2, X_POS
               GoSub NOKIA_BAR
               Endm

;----- NOKIA ICON MACRO ---------
NOKIA_ICON Macro P1,P2,P3                 ; P1 = Y, P2 = X, P3 = ICON NUMBER
           NUM_BYTE P1,Y_POS
           NUM_BYTE P2,X_POS
           #if (Prm_3 == Num8)
               NUM_BYTE P3,ICON_NR
           #else
               BYTE_BYTE P3,ICON_NR
           #endif
           GoSub NOKIA_ICN
           Endm

;----- NOKIA IMAGE MACRO ---------
NOKIA_IMAGE Macro P1,P2                 ' P1 = IMAGE NUMBER   P2= MODE 0 NORMAL  OR 1 INVERTED
            #if (Prm_1 == Num8)
               NUM_BYTE P1,IMG_NR
            #else
               BYTE_BYTE P1,IMG_NR
            #endif
            NUM_BYTE P2,MODE
            GoSub NOKIA_IMG
            Endm
OVER_MACROS:

